/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsyste

 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package carto;

import java.awt.*;
import java.io.Serializable;

/**
 *
 * @author  Laurent Jégou
 */
public class AnalyseSymboles implements Serializable{
    
    public int typeSymbole; //0 = cercle, 1 = carré.
    public double cS;
    public Color couleurSymbole;
    public Color couleurContour;
    public Color couleurEvides;
    public Color couleurEvidesNeg;
    public Color couleurSymboleNeg;
    public Color couleurContourNeg;
    public double opacite = 1;
    public double coeffCorrection; // é verifier
    public int typeProportion; // 0 = lineaire, 1 = racine, 2 = log.
    public String champ;
    public double facteurRacine = 2;
    public String titreLegende;
    public String sousTitreL;
    public int surfRef;
    public double valeurReference;
    public double valVide;
    public double classValVide;
    public double legMinValeur;
    public double legMedValeur;
    public double legMaxValeur;
    public int legMinIndex;
    public int legMaxIndex;
    public int legMedIndex;
    public int champNum = -1;
    
    /** Creates a new instance of AnalyseSymboles */
    public AnalyseSymboles() {
        super();
    }
 
    protected Object clone() {
        try {
            AnalyseSymboles as2 = null;
            as2 = (AnalyseSymboles) super.clone();
            return as2;
        } catch (CloneNotSupportedException x) {
            return (new InternalError(Messages.getString("Carte.0"))); //$NON-NLS-1$
        }
    }

    public AnalyseSymboles copie() {
    	AnalyseSymboles as2 = new AnalyseSymboles();
    	as2.champ = this.champ;
    	as2.champNum = this.champNum;
    	as2.valeurReference = this.valeurReference;
    	as2.classValVide = this.classValVide;
    	as2.coeffCorrection = this.coeffCorrection;
    	as2.couleurContour = this.couleurContour;
    	as2.couleurContourNeg = this.couleurContourNeg;
    	as2.couleurEvides = this.couleurEvides;
    	as2.couleurSymbole = this.couleurSymbole;
    	as2.couleurSymboleNeg = this.couleurSymboleNeg;
    	as2.cS = this.cS;
    	as2.facteurRacine = this.facteurRacine;
    	as2.legMaxIndex = this.legMaxIndex;
    	as2.legMaxValeur = this.legMaxValeur;
    	as2.legMedIndex = this.legMedIndex;
    	as2.legMedValeur = this.legMedValeur;
    	as2.legMinIndex = this.legMinIndex;
    	as2.legMinValeur = this.legMinValeur;
    	as2.opacite = this.opacite;
    	as2.sousTitreL = this.sousTitreL;
    	as2.surfRef = this.surfRef;
    	as2.titreLegende = this.titreLegende;
    	as2.surfRef = this.surfRef;
    	as2.typeProportion = this.typeProportion;
    	as2.typeSymbole = this.typeSymbole;
    	as2.valVide = this.valVide;
    	return as2;
    }
    
    public void vide() {
        
    }
    
    public void setChampNum(int valeur) {
        this.champNum = valeur;
    }

    public int getChampNum() {
        return this.champNum;
    }
}
