/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package donnees;

import java.awt.Component;

import javax.swing.AbstractCellEditor;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableCellEditor;

/**
 * @author Laurent
 *  
 */
public class NullTableCellEditor extends AbstractCellEditor implements TableCellEditor {

    Object value;

    JComponent component = new JTextField();

    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        this.value = value;
        if (isSelected) {
            //
        }
        if (value == null)
            value = "é"; //$NON-NLS-1$
        ((JTextField) component).setText(String.valueOf(value));
        return component;
    }

    public Object getCellEditorValue() {
        if (((JTextField) component).getText().equals("")) { //$NON-NLS-1$
            //    return null;
            if (value.getClass() == Integer.class)
                return new Integer(0);
            if (value.getClass() == Double.class)
                return new Double(0);
        } else {
            if (value.getClass() == Integer.class)
                return Integer.valueOf(((JTextField) component).getText());
            if (value.getClass() == Double.class)
                return Double.valueOf(((JTextField) component).getText());
        }
        return ""; //$NON-NLS-1$
    }
}