/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.ExpandVetoException;

public class Arborescence extends JPanel {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected DefaultMutableTreeNode racine;

    protected DefaultTreeModel modele;

    protected JTree arbre;

    private JScrollPane scrollPane;

    private JScrollBar scrollBarH;

    private JScrollBar scrollBarV;

    /** Creates a new instance of Arborescance */
    public Arborescence() {

        racine = new DefaultMutableTreeNode("Scap"); //$NON-NLS-1$
        modele = new DefaultTreeModel(racine, true);
        arbre = new JTree(modele);

        scrollPane = new JScrollPane(arbre);
        scrollBarH = new JScrollBar(JScrollBar.HORIZONTAL);
        scrollBarV = new JScrollBar(JScrollBar.VERTICAL);

        arbre.setEditable(true);

        arbre.setShowsRootHandles(false);
        //selectionne le noeud racine
        arbre.setSelectionRow(0);

        modele.reload();

        scrollPane.setHorizontalScrollBar(scrollBarH);
        scrollPane.setVerticalScrollBar(scrollBarV);

        int hauteur = java.awt.Toolkit.getDefaultToolkit().getScreenSize().height;
        scrollPane.setPreferredSize(new Dimension(140, hauteur));

        this.add(scrollPane);

        this.setBackground(new Color(0, 204, 204));
        this.setPreferredSize(new Dimension(140, 10));

        // Il va sans doute falloir redéfinir la méthode qui dit
        // ce qu'on fait lorsqu'un noeud est collapsé.
        arbre.addTreeWillExpandListener(new TreeWillExpandListener() {

            // L'arbre s'etend
            public void treeWillExpand(TreeExpansionEvent event) throws ExpandVetoException {
            }

            // L'arbre est collapsé: lorsque l'on va collapser un repertoire
            // il faut regarder si la carte selectionnée appartient au noeud
            public void treeWillCollapse(TreeExpansionEvent event) throws ExpandVetoException {

            }
        });

        // Listener qui ecoute si la selection courante a change
        arbre.addTreeSelectionListener(new TreeSelectionListener() {
            // Méthode qui implemente ce qu'on fait lorsque la selection a
            // changé
            // (il faut selectionner une autre fenetre dans lengthJDesktopFrame)
            public void valueChanged(TreeSelectionEvent e) {
            }
        });

    }

}