/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.util.Arrays;
import java.util.Vector;

import carto.Carte;
import carto.ClasseDiscret;
import donnees.champDonnees;

/**
 * @author Laurent
 */

public class BoiteDialogueGraphique extends javax.swing.JDialog {
    public Vector colonnes;

    public Vector data;
    
    public Carte carte;

    private int ni = 0;
    
    private int nbFR = 0;
    
    private double vmin = 0, vmax = 0;
    
    private double[][] grBornesV;  //Bornes des fréquences valeur
    
    private int[] grCI; //Nombre d'individus par classe equivalente
    
    private long hMax = 0;
    
    /** Creates new form BDGraphique */
    public BoiteDialogueGraphique(FenetrePrincipale parent, boolean modal, Carte tempCarte, Vector champs, Vector table) {
        super(parent, modal);
        this.setResizable(false);
        this.carte = tempCarte;
        this.colonnes = champs;
        this.data = table;
        this.ni = (data.size() / colonnes.size());
        initComponents();
        grDisecEquivalences();
        grRafraichit();
        jPanel1 = new PanneauGraphique(nbFR, carte, this, grBornesV, grCI, hMax, vmin, vmax);
        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 380, 220));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    private void initComponents() {
        jBFermer = new javax.swing.JButton();
        //jPanel1 = new graphiqueJPanel();
        jLabel1 = new javax.swing.JLabel();
        jLCl = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLN = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLV = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLF = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jSlider1 = new javax.swing.JSlider();
        jLNB = new javax.swing.JLabel();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jBFermer.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jBFermer.setText(Messages.getString("BoiteDialogueGraphique.1"));         //$NON-NLS-1$
        jBFermer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBFermerActionPerformed(evt);
            }
        });
        getContentPane().add(jBFermer, new org.netbeans.lib.awtextra.AbsoluteConstraints(340, 270, -1, -1));

        /*jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 380, 220));*/

        jLabel1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLabel1.setText(Messages.getString("BoiteDialogueGraphique.3")); //$NON-NLS-1$
        getContentPane().add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 250, -1, -1));

        jLCl.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLCl.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLCl.setText("_"); //$NON-NLS-1$
        getContentPane().add(jLCl, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 250, 10, -1));

        jLabel2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLabel2.setText(Messages.getString("BoiteDialogueGraphique.7")); //$NON-NLS-1$
        getContentPane().add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 270, -1, -1));

        jLN.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLN.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLN.setText("_"); //$NON-NLS-1$
        getContentPane().add(jLN, new org.netbeans.lib.awtextra.AbsoluteConstraints(72, 270, 30, -1));

        jLabel3.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLabel3.setText(Messages.getString("BoiteDialogueGraphique.11")); //$NON-NLS-1$
        getContentPane().add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 230, -1, -1));

        jLV.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLV.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLV.setText("_"); //$NON-NLS-1$
        getContentPane().add(jLV, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 230, 58, -1));

        jLabel4.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLabel4.setText(Messages.getString("BoiteDialogueGraphique.15")); //$NON-NLS-1$
        getContentPane().add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(114, 270, -1, -1));

        jLF.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLF.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLF.setText("_"); //$NON-NLS-1$
        getContentPane().add(jLF, new org.netbeans.lib.awtextra.AbsoluteConstraints(174, 270, 30, -1));

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator1.setPreferredSize(new java.awt.Dimension(20, 40));
        getContentPane().add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(138, 230, 6, 30));

        getContentPane().add(jSeparator2, new org.netbeans.lib.awtextra.AbsoluteConstraints(138, 260, 246, -1));

        jSlider1.setValue(30);
        jSlider1.setMinimum(2);
        jSlider1.setMaximum(ni);
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });

        getContentPane().add(jSlider1, new org.netbeans.lib.awtextra.AbsoluteConstraints(222, 230, 162, -1));

        jLNB.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jLNB.setText(Messages.getString("BoiteDialogueGraphique.19")); //$NON-NLS-1$
        getContentPane().add(jLNB, new org.netbeans.lib.awtextra.AbsoluteConstraints(144, 235, 78, -1));

        pack();
    }
    
    private void jBFermerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {
        grDisecEquivalences();
        grRafraichit();
        jPanel1.majFR(jSlider1.getValue(), grBornesV, grCI);
    }
    
    private void grDisecEquivalences() {
        //Discrétisation équivalences : calcul des bornes et des tailles
        int i = 0;
        nbFR = jSlider1.getValue();
        int ni = data.size() / colonnes.size();
        double[] valeurs = getValeursTriees();
        vmin = valeurs[0];
        vmax = valeurs[ni - 1];
        double largeur = (vmax - vmin) / nbFR;
        int compteur = 0;
        int clec = 0;
        double debClec = 0;
        int dernier = 0;
        grBornesV = new double[nbFR][2];
        grCI = new int[nbFR];
        //Calcul bornes pour des classes de méme largeur
        grBornesV[0][0] = valeurs[0];
        debClec = valeurs[0];
        for (i = 0; i < ni; i++) {
            compteur += 1;
            dernier += 1;
            if (valeurs[i] > (debClec + largeur)) {
                grBornesV[clec][1] = valeurs[i];
                grCI[clec] = compteur - 1;
                compteur = 0;
                debClec = valeurs[i];
                if (clec < (nbFR - 1)) clec += 1; else break;
                grBornesV[clec][0] = valeurs[i];
            }
        }
        if ((clec - 1) < (nbFR - 2)) {
            int diff = (nbFR - 2) - (clec - 1);
            for (i = 0; i < diff; i++) {
                grBornesV[clec + i][0] = valeurs[ni - 1]; 
                grBornesV[clec + i][1] = valeurs[ni - 1];              
                grCI[clec + i] = 0;      
            }
        }
        grBornesV[nbFR - 1][0] = grBornesV[nbFR - 2][1];                                        
        grBornesV[nbFR - 1][1] = valeurs[ni - 1];                    
        grCI[nbFR - 1] = (ni - dernier + 1);      
    }

    private double[] getValeursTriees() {
        int i = 0;
        int ni = data.size() / colonnes.size();
        double[] valeurs = new double[ni];
        for (i = 0; i < ni; i++) {
            int position = (i * colonnes.size()) + carte.analysePlages.champNum;
            switch (((champDonnees) colonnes.get(carte.analysePlages.champNum)).typeI) {
            case 0:
                valeurs[i] = ((Integer) data.elementAt(position)).doubleValue();
                break;
            case 2:
                valeurs[i] = ((Double) data.elementAt(position)).doubleValue();
                break;
            }
        }
        Arrays.sort(valeurs);
        return valeurs;
    }

    private void grRafraichit() {
        int i = 0;
        long modeV = 0; //Mode valeurs
        long modeF = 0; //Mode fréquences
        int nbFR = jSlider1.getValue();
        int ni = data.size() / colonnes.size();
        double[] valeurs = getValeursTriees();
        double vmin = valeurs[0];
        double vmax = valeurs[ni - 1];
        double etendue = Math.abs(vmax - vmin);
        double pas = etendue / nbFR;
        for (i = 0; i < carte.analysePlages.nbreClasses; i++) {
            if (((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).nbreIndividus > modeV)
                modeV = ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).nbreIndividus;
        }
        for (i = 0; i < nbFR; i++) {
            if (grCI[i] > modeF) modeF = grCI[i];
        }
        if (modeV > modeF) hMax = modeV; else hMax = modeF;
    }   
    
    public void afficheValeur(double valeur) {
        jLV.setText(String.valueOf(valeur));
    }
    
    public void afficheClasse(int classe) {
        jLCl.setText(String.valueOf(classe + 1));
    }
    
    public void afficheN(long n) {
        jLN.setText(String.valueOf(n));
    }
    
    public void afficheF(float f) {
        jLF.setText(String.valueOf(f));
    }
    
    // Variables declaration - do not modify
    private javax.swing.JButton jBFermer;

    private javax.swing.JLabel jLCl;

    private javax.swing.JLabel jLF;

    private javax.swing.JLabel jLN;

    private javax.swing.JLabel jLV;

    private javax.swing.JLabel jLabel1;

    private javax.swing.JLabel jLabel2;

    private javax.swing.JLabel jLabel3;

    private javax.swing.JLabel jLabel4;

    private javax.swing.JLabel jLNB;

    private PanneauGraphique jPanel1;

    private javax.swing.JSeparator jSeparator1;

    private javax.swing.JSeparator jSeparator2;

    private javax.swing.JSlider jSlider1;
    // End of variables declaration

}