/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Cursor;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


public class BoiteDialogueTrier extends JDialog implements ActionListener{
   
    public Vector columnNames;
    public Vector tableau;
    public FenetrePrincipale fen;

    
    public BoiteDialogueTrier(FenetrePrincipale f, Vector c, Vector t) {
        super(f, Messages.getString("BoiteDialogueTrier.0"), true);      //$NON-NLS-1$
        this.fen = f;
        this.columnNames = c;
        this.tableau = t;
        
        
        jLabel = new javax.swing.JLabel();
        bok = new javax.swing.JButton();
        bcancel= new javax.swing.JButton();
        jComboBox = new javax.swing.JComboBox(c);
        jPanelSud = new JPanel();
        jPanelBouton=new JPanel();
        jPanelOrdreTri = new JPanel();
        jOrdreCroi = new JCheckBox(Messages.getString("BoiteDialogueTrier.1"),false); //$NON-NLS-1$
        jOrdreDeCroi = new JCheckBox(Messages.getString("BoiteDialogueTrier.2"),false); //$NON-NLS-1$
        
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
                    
        GridLayout fl = new GridLayout(2,1,1,1);
        jPanelSud.setLayout(fl);
        
        jPanelOrdreTri.setBorder( new javax.swing.border.TitledBorder(null,Messages.getString("BoiteDialogueTrier.3"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION,  new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 51, 51))); //$NON-NLS-1$ //$NON-NLS-2$
       
        jOrdreCroi.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jPanelOrdreTri.add(jOrdreCroi);
        jOrdreCroi.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jOrdreCroiActionPerformed(evt);
            }});
        jOrdreDeCroi.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jOrdreDeCroi.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jOrdreDeCroiActionPerformed(evt);
            }});
        jPanelOrdreTri.add(jOrdreDeCroi);
        jPanelSud.add(jPanelOrdreTri);
        
        
        
        bok.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bok.setText(Messages.getString("BoiteDialogueTrier.8")); //$NON-NLS-1$
        bok.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanelBouton.add(bok);
        bok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bokActionPerformed(evt);
            }});

        bcancel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bcancel.setText(Messages.getString("BoiteDialogueTrier.10")); //$NON-NLS-1$
        bcancel.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanelBouton.add(bcancel);
        bcancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bcancelActionPerformed(evt);
            }});
            
        jPanelSud.add(jPanelBouton); 
        
        
        getContentPane().add(jPanelSud, java.awt.BorderLayout.SOUTH);
        
                
        jLabel.setText(Messages.getString("BoiteDialogueTrier.11")); //$NON-NLS-1$
        jLabel.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        jLabel.setForeground(new java.awt.Color(0, 51, 51));
        
        getContentPane().add(jLabel, java.awt.BorderLayout.NORTH);

        jComboBox.setMaximumRowCount(20);
        jComboBox.setBackground(new java.awt.Color(255, 255, 255));
        jComboBox.setPreferredSize(new java.awt.Dimension(300, 22));
        getContentPane().add(jComboBox, java.awt.BorderLayout.CENTER);
        
        pack();
    }
    
    /** Closes the dialog */
    public void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }
    

   public void bcancelActionPerformed(java.awt.event.ActionEvent evt){
        setVisible(false);
        dispose();
    }
    
    public void jOrdreCroiActionPerformed(java.awt.event.ActionEvent evt){
        jOrdreCroi.setSelected(true);
        jOrdreDeCroi.setSelected(false);
     
    }
    
    public void jOrdreDeCroiActionPerformed(java.awt.event.ActionEvent evt){
        jOrdreCroi.setSelected(false);
        jOrdreDeCroi.setSelected(true);
    }
    
    
    public void bokActionPerformed(java.awt.event.ActionEvent evt){
        if (jOrdreCroi.isSelected()==false && jOrdreDeCroi.isSelected()==false) JOptionPane.showMessageDialog(fen,Messages.getString("BoiteDialogueTrier.13"));  // une boite de dialogue de controle arrive si l'ordre de tri n'a pas été precisé //$NON-NLS-1$
        else {
        this.setCursor(new Cursor(3));                
        String champ=jComboBox.getSelectedItem().toString();  //recupere le champ selectionné dans le combobox
        boolean ordre=jOrdreCroi.isSelected();   //recupere l'ordre de tri selectionné
       
        fen.afficherTableTrierCol(champ,ordre);
        setVisible(false);
        dispose();    
        this.setCursor(new Cursor(0));}        
    }
       
    public void afficherBoiteDialogue(){
        this.setLocationRelativeTo(fen);
        this.setVisible(true);
    }
   
            
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {        
    
    }    
    
    // Variables declaration - do not modify
    private javax.swing.JButton bcancel;
    private javax.swing.JButton bok;
    private JPanel jPanelBouton;
    private JPanel jPanelSud;
    private JPanel jPanelOrdreTri;
    private JCheckBox jOrdreCroi;
    private JCheckBox jOrdreDeCroi;
    private javax.swing.JLabel jLabel;
    private javax.swing.JTable table;
    private javax.swing.JComboBox jComboBox;
   
    // End of variables declaration
    
     
}
