/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JInternalFrame;

public class FenetreCarte extends JInternalFrame {

    public FenetreMilieu base;

    public PanneauCarte panneauCarte;

    public FenetreCarte(FenetreMilieu parent, String titre, String action, String fond) {
        super(titre, true, true, true, true);
        this.base = parent;
        ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
        this.setFrameIcon(icone);
        if (action.equals("importation")) { //$NON-NLS-1$
            panneauCarte = new PanneauCarte(this, "importation", fond); //$NON-NLS-1$
        } else {
            panneauCarte = new PanneauCarte(this, "ouverture", fond); //$NON-NLS-1$
        }
        panneauCarte.setBounds(0, 0, WIDTH, HEIGHT);
        panneauCarte.setBackground(new Color(255, 255, 255));
        this.getContentPane().add(panneauCarte);
    }

    public FenetreMilieu getBase() {
        return this.base;
    }

    /*
     * Méthode d'accés au champ panneauCarte (plus necessaire accés é l'attribut
     * panneauCarte laissé public pour faciliter l'accés au fond de carte)
     */
    public PanneauCarte getPanneauCarte() {
        return this.panneauCarte;
    }

}