/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

import javax.swing.JPanel;

import carto.Carte;
import carto.ClasseDiscret;

/**
 * @author Laurent
 *  
 */
public class PanneauGraphique extends JPanel implements MouseMotionListener {

    private BoiteDialogueGraphique BDgr;

    private int nbFR;

    private long hMax;

    private double vmin, vmax;

    private double[][] grBornesV;

    private int[] grCI;

    private Carte carte;

    private float coefV, coefH;

    private int gauche;

    public PanneauGraphique(int nbFR, Carte carte, BoiteDialogueGraphique BDgr, double[][] grBornesV, int[] grCI, long hMax, double vmin, double vmax) {
        this.nbFR = nbFR;
        this.BDgr = BDgr;
        this.carte = carte;
        this.hMax = hMax;
        this.vmin = vmin;
        this.vmax = vmax;
        this.grBornesV = grBornesV;
        this.grCI = grCI;
        addMouseMotionListener(this);
        repaint();
    }

    public void majFR(int nbFR, double[][] grBornesV, int[] grCI) {
        this.nbFR = nbFR;
        this.grBornesV = grBornesV;
        this.grCI = grCI;
        this.repaint();
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        int i, a1, a2, a3, a4;
        Graphics2D g2 = (Graphics2D) g;
        Dimension d = this.getSize();
        double etendue = vmax - vmin;
        coefV = (d.height - 30) / (float) hMax;
        coefH = (d.width - 30) / (float) (etendue);
        int bas = d.height - 15;
        //g2.clearRect(0, 0, d.width, d.height);
        if (vmin < 0) {
            gauche = (int) (15 + Math.abs(vmin) * coefH);
        } else {
            gauche = (int) (15 - Math.abs(vmin) * coefH);
        }
        //Dessin de la variable
        for (i = 0; i < carte.analysePlages.nbreClasses; i++) {
            a1 = (int) (gauche + ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).limiteInf * coefH);
            a2 = (int) (bas - ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).nbreIndividus * coefV);
            a3 = (int) (gauche + ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).limiteSup * coefH) - a1;
            a4 = (int) (bas - a2);
            g2.setPaint(((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).couleur);
            g2.fillRect(a1, a2, a3, a4);
            g2.setPaint(Color.black);
            g2.drawRect(a1, a2, a3, a4);
        }
        //Dessin des barres de fréquences grises
        Color grisTr = new Color(200, 200, 200, 100);
        for (i = 0; i < nbFR; i++) {
            a1 = (int) (gauche + (grBornesV[i][0] * coefH));
            a2 = (int) (bas - (grCI[i] * coefV));
            a3 = (int) (gauche + (grBornesV[i][1] * coefH)) - a1;
            a4 = (int) (bas - a2);
            g2.setPaint(grisTr);
            g2.fillRect(a1, a2, a3, a4);
            g2.setPaint(Color.white);
            g2.drawRect(a1, a2, a3, a4);
        }
    }

    public void mouseClicked(MouseEvent me) {
    }

    public void mousePressed(MouseEvent me) {
    }

    public void mouseReleased(MouseEvent me) {
    }

    public void mouseEntered(MouseEvent me) {
    }

    public void mouseExited(MouseEvent me) {
    }

    public void mouseDragged(MouseEvent me) {
    }

    public void mouseMoved(MouseEvent me) {
        int i = 0;
        Point position = me.getPoint();
        double valeur = vmin + ((position.x - gauche) / coefH);
        BDgr.afficheValeur(valeur);
        for (i = 0; i < carte.analysePlages.nbreClasses; i++) {
            double bmin = ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).limiteInf;
            double bmax = ((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).limiteSup;
            if (i == carte.analysePlages.nbreClasses)
                bmax += 1;
            if (valeur >= bmin && valeur < bmax) {
                BDgr.afficheClasse(i);
                BDgr.afficheN(((ClasseDiscret) carte.analysePlages.classes.elementAt(i)).nbreIndividus);
                break;
            }
        }
        for (i = 0; i < nbFR; i++) {
            if (valeur >= grBornesV[i][0] && valeur < grBornesV[i][1]) {
                BDgr.afficheF(grCI[i]);
                break;
            }
        }
    }
}