
/*
 * 2 décembre 2004 - 16h00
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.NoSuchElementException;

import donnees.Messages;

/**
 * @author Laurent
 */

public class fichierINI {
	
	private File m_fichierINI;
	
	private String m_name;
	
	private String m_path;

	public fichierINI() {
		m_fichierINI = new File(System.getProperty("user.dir") + System.getProperty("file.separator") + "scapj.ini"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		lire();
	}
	
	public String getName() {
		return this.m_name;
	}
	
	public String getPath() {
		return this.m_path;
	}
	
	public boolean ecrire(String fichier) {
        try {
            FileWriter fw = new FileWriter(m_fichierINI);
            BufferedWriter bw = new BufferedWriter(fw);
            this.m_name = fichier;
            this.m_path = fichier;
            bw.write(fichier);
            bw.close();
            fw.close();
        } catch (NoSuchElementException e) {
            System.out.println(Messages.getString("TableModel.51") + e.getMessage()); //$NON-NLS-1$
            System.exit(1);
            return false;
        } catch (IOException e) {
            System.out.println(Messages.getString("TableModel.52") + e.getMessage()); //$NON-NLS-1$
            System.exit(1);
            return false;
        }
		return true;
	}
	
	public String lire() {
		String dernierFichier = new String();	
		try {
			if (m_fichierINI.exists() == false) {
				ecrire(Messages.getString("fichierINI.3")); //$NON-NLS-1$
			}
			BufferedReader fileInput = new BufferedReader(new InputStreamReader(new FileInputStream(m_fichierINI)));
			dernierFichier = fileInput.readLine();
			this.m_name = dernierFichier;
			this.m_path = dernierFichier;
        } catch (NoSuchElementException e) {
            System.out.println(Messages.getString("TableModel.8") + e.getMessage()); //$NON-NLS-1$
            System.exit(1);
        } catch (IOException e) {
            System.out.println(Messages.getString("TableModel.9") + e.getMessage()); //$NON-NLS-1$
            System.exit(1);
        	
        }
		return dernierFichier;
	}
	
}
